﻿namespace ProjectStormtrooper;

/// <summary>
/// Класс-сущность "Штурмовик"
/// </summary>
public class EntityStormtrooper
{
    /// <summary>
    /// Скорость
    /// </summary>
    public int Speed { get; private set; }

    /// <summary>
    /// Вес
    /// </summary>
    public double Weight { get; private set; }

    /// <summary>
    /// Основной цвет
    /// </summary>
    /// 
    public Color BodyColor { get; private set; }
    /// <summary>
    /// Дополнительный цвет (для опциональных элементов)
    /// </summary>
    public Color AdditionalColor { get; private set; }

    /// <summary>
    /// Признак (опция) наличия ракет
    /// </summary>
    public bool Rockets { get; private set; }

    /// <summary>
    /// Признак (опция) наличия бомб
    /// </summary>
    public bool Bombs { get; private set; }

    /// <summary>
    /// Шаг перемещения штурмовика
    /// </summary>
    public double Step => Speed * 100 / Weight;

    /// <summary>
    /// Инициализация полей объекта-класса штурмовик
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес </param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="rockets">Признак наличия ракет</param>
    /// <param name="bombs">Признак наличия бомб</param>

    public void Init(int speed, double weight, Color bodyColor, Color additionalColor, bool rockets, bool bombs)
    {
        Speed = speed;
        Weight = weight;
        BodyColor = bodyColor;
        AdditionalColor = additionalColor;
        Rockets = rockets;
        Bombs = bombs;
        
    }
}

