﻿namespace ProjectStormtrooper;
/// <summary>
/// Форма работы с объектом "Штурмовик"
/// </summary>
public partial class FormStormtrooper : Form
{/// <summary>
/// Поле-объект для прорисовки объекта
/// </summary>
    private DrawingStormtrooper? _drawningStormtrooper;
    /// <summary>
    /// Конструктор формы
    /// </summary>
    public FormStormtrooper()
    {
        InitializeComponent();
    }

    /// <summary>
    /// Метод прорисовки штурмовика
    /// </summary>

    private void Draw()
    {
        if (_drawningStormtrooper == null)
        {
            return;
        }

        Bitmap bmp = new(pictureBoxStormtrooper.Width, pictureBoxStormtrooper.Height);
        Graphics gr = Graphics.FromImage(bmp);
        _drawningStormtrooper.DrawTransport(gr);
        pictureBoxStormtrooper.Image = bmp;
    }
    /// <summary>
    /// Обработка нажатия кнопки "Создать"
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void ButtonCreateStormtrooper_Click(object sender, EventArgs e)
    {
        Random random = new();
        _drawningStormtrooper = new DrawingStormtrooper();
        _drawningStormtrooper.Init(random.Next(100, 300), random.Next(1000, 3000),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)));
        _drawningStormtrooper.SetPictureSize(pictureBoxStormtrooper.Width, pictureBoxStormtrooper.Height);
        _drawningStormtrooper.SetPosition(random.Next(10, 100), random.Next(10, 100));

        Draw();
    }
    /// <summary>
    /// Перемещение объкта по форме(нажатие кнопок навигации)
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void ButtonMove_Click(object sender, EventArgs e)
    {
        if (_drawningStormtrooper == null)
        {
            return;
        }

        string name = ((Button)sender)?.Name ?? string.Empty;
        bool result = false;
        switch (name)
        {
            case "buttonUp":
                result = _drawningStormtrooper.MoveTransport(DirectionType.Up);
                break;
            case "buttonDown":
                result = _drawningStormtrooper.MoveTransport(DirectionType.Down);
                break;
            case "buttonLeft":
                result = _drawningStormtrooper.MoveTransport(DirectionType.Left);
                break;
            case "buttonRight":
                result = _drawningStormtrooper.MoveTransport(DirectionType.Right);
                break;
        }

        if (result)
        {
            Draw();
        }

    }
}
